/// <reference types="react" />
import { TextFieldProps } from '@material-ui/core/TextField';
import FieldCoreBase, { IStateFieldBase } from '@react-form-fields/core/components/FieldCoreBase';
import { StylesConfig } from 'react-select/lib/styles';
import { IStyledProps } from '../../decorators/withStyles';
import { AutoCompletePropsResolver, IBaseFieldProps } from '../../interfaces/props';
interface IState extends IStateFieldBase {
    term: string;
    value: string;
    suggestions: IProps['options'][0][];
    focused: boolean;
}
interface IProps extends IBaseFieldProps, IStyledProps, AutoCompletePropsResolver {
    value: any | any[];
    placeholder?: string;
    onChange: (value: any) => void;
    options: {
        value: any;
        label: string;
    }[];
    TextFieldProps?: TextFieldProps;
    helperText?: string;
    margin?: TextFieldProps['margin'];
    variant?: TextFieldProps['variant'];
    disabled?: boolean;
}
export default class FieldAutocomplete extends FieldCoreBase<IProps, IState> {
    styles: StylesConfig;
    onChange: (value: {
        value: any;
        label: string;
    } | {
        value: any;
        label: string;
    }[]) => void;
    onFocus: (e: any) => void;
    onBlur: (e: any) => void;
    readonly value: {
        value: any;
        label: string;
    } | {
        value: any;
        label: string;
    }[];
    render(): JSX.Element;
}
export {};
