import FieldCoreBase, { IStateFieldBase } from '@react-form-fields/core/components/FieldCoreBase';
import * as React from 'react';
import { HTMLAttributesResolver, IBaseFieldProps } from '../../interfaces/props';
interface IState extends IStateFieldBase {
    focused: boolean;
}
interface IProps extends IBaseFieldProps, HTMLAttributesResolver {
    helperText?: React.ReactNode;
    placeholder?: string;
    disabled?: boolean;
}
export default class FieldHtml extends FieldCoreBase<IProps, IState> {
    dependenciesLoaded: Promise<string>;
    instance: any;
    textareaRef: React.RefObject<HTMLTextAreaElement>;
    constructor(props: IProps);
    loadDependencies: () => Promise<any>;
    componentDidMount(): Promise<void>;
    componentDidUpdate(): void;
    onChange: (value: string) => void;
    onBlur: (value: string) => void;
    onFocus: () => void;
    render(): JSX.Element;
}
export {};
